///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK TimeToRegisterDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    static HWND RegistrationListBox_hWnd = NULL;
    static HWND TimerText_hWnd           = NULL;

    static TimeUntillEnable              = 0;

	if(xMessage == WM_INITDIALOG) // Received an initilize dialog message
	{
		TimeToRegisterDialog_hWnd = xHandle;

		SendMessage(TimeToRegisterDialog_hWnd,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)"Register now.");
		SendMessage(TimeToRegisterDialog_hWnd,WM_SETICON,TRUE,(LPARAM)LoadIcon(MainInstance,MAKEINTRESOURCE(DialogIcon)));

        RegistrationListBox_hWnd = GetDlgItem(TimeToRegisterDialog_hWnd, IDC_REGLIST);
        TimerText_hWnd           = GetDlgItem(TimeToRegisterDialog_hWnd, IDC_TIMERTEXT);

        InsertListBoxItem(RegistrationListBox_hWnd, "Desired registrarion text. Desired registrarion text. Desired registrarion text.", -1);
        InsertListBoxItem(RegistrationListBox_hWnd, "Desired registrarion text. Desired registrarion text. Desired registrarion text.", -1);
        InsertListBoxItem(RegistrationListBox_hWnd, "Desired registrarion text. Desired registrarion text. Desired registrarion text.", -1);
        InsertListBoxItem(RegistrationListBox_hWnd, "Desired registrarion text. Desired registrarion text. Desired registrarion text.", -1);
        InsertListBoxItem(RegistrationListBox_hWnd, "Desired registrarion text. Desired registrarion text. Desired registrarion text.", -1);
        InsertListBoxItem(RegistrationListBox_hWnd, "Desired registrarion text. Desired registrarion text. Desired registrarion text.", -1);
        InsertListBoxItem(RegistrationListBox_hWnd, "Desired registrarion text. Desired registrarion text. Desired registrarion text.", -1);

		CenterWindow(TimeToRegisterDialog_hWnd);

        TimeUntillEnable = 4;

        SetTimer(TimeToRegisterDialog_hWnd, 1, 1000, NULL);

		return 0;
	}

    //--------------------------------------------------------------------------

	if(xMessage == WM_COMMAND) // Received a message
	{
        if(wParam==IDC_OKBUTTON) //- Ok (Dialog Menu Command)
        {
            EndDialog(TimeToRegisterDialog_hWnd, 0);
            DestroyWindow(TimeToRegisterDialog_hWnd);
            KillTimer(TimeToRegisterDialog_hWnd, 1);
            return 0;
        }

  		return 0;
	}

    //--------------------------------------------------------------------------

    if((HANDLE)lParam == RegistrationListBox_hWnd)
        return Set_Color( RGB(0,0,100), RGB(255,255,255), wParam);

    //--------------------------------------------------------------------------

    if((HANDLE)lParam == TimerText_hWnd)
        return Set_Color( RGB(0,0,100), RGB(255,255,255), wParam);

    //--------------------------------------------------------------------------

    if(xMessage == WM_TIMER)
    {
        if(TimeUntillEnable == 0)
        {
            EnableWindow(GetDlgItem(TimeToRegisterDialog_hWnd, IDC_OKBUTTON), TRUE);
            Set_Text(TimerText_hWnd, "Trial version.");
        }
        else{
            char Temp[56];
            sprintf(Temp, "Trial version. Please wait: %d", TimeUntillEnable);
            Set_Text(TimerText_hWnd, Temp);
            TimeUntillEnable--;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

