//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <StdIO.H>

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "Headers/NSWFL.H"
#include "Headers/NASCCL.H"
#include "Headers/NDBSCore.H"
#include "Headers/NDBSFIO.H"

#include "Headers/KeyGen.H"

#define KeyToUse       "LhDTiyrCQ6fues5pXEuo2i4Mg3IgvXe4STWQEROgqHFX8eQwfySDUhg8QwqGmuIvt2F36jhT4FouWNEqtDoucTlgjuOnSVstBqs7QPCu4x84ndnNitydDgwUPmlgFtle"
#define KeyHashSize    1024
#define RegCodesToMake 10000

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int main(void)
{
    int LocalLoop = 0;

	srand( GenerateSeed() );

    //------------------------------------------------------------------------------------

    FILE *RawKeys  = NULL;

    if((RawKeys = fopen("C:\\RegKeys.txt", "wb")) == NULL)
        return FALSE;

    //------------------------------------------------------------------------------------

    char *ColumbName  = NULL;

    _NDataBaseSystem NDBS;

	InitializeNDBS(&NDBS, 3, RegCodesToMake + 1);

    ColumbName = "Key1";
    AddColumb(&NDBS, ColumbName, strlen(ColumbName));

    ColumbName = "Key2";
    AddColumb(&NDBS, ColumbName, strlen(ColumbName));

    ColumbName = "Key3";
    AddColumb(&NDBS, ColumbName, strlen(ColumbName));

    //------------------------------------------------------------------------------------

    _NASCCL Crypt;

    int Attribs = (ROUNDMUTATION | SWAPMATRIX | ROUNDRESULT | NONREPETITION | ENSUREOFFSET | FMATRIXMUTATION | RMATRIXMUTATION | CMATRIXMUTATION | CRYPTFULLDATASET | RUNNINGKEYPOSITION);

    char KeyHash[KeyHashSize + 1];

    HashKey(KeyToUse, KeyHash, strlen(KeyToUse), KeyHashSize);

    InitializeCryptographySet(&Crypt, KeyHash, KeyHashSize, Attribs);

    Crypt.Data  = (char *) calloc(8 + 1, 1);

    Crypt.SizeOfData = 8;

    //------------------------------------------------------------------------------------

    while(LocalLoop < RegCodesToMake)
    {
    	char Encoded[8 + 1];

        KeyGen(8, GKNUMBERS|GKLOWER_AZ, Crypt.Data);
        fprintf(RawKeys, "%s-", Crypt.Data);
        Encode(&Crypt, Encoded);
        AddEntryByColumbName(&NDBS, "Key1", Encoded, 8);

        KeyGen(8, GKNUMBERS|GKLOWER_AZ, Crypt.Data);
        fprintf(RawKeys, "%s-", Crypt.Data);
        Encode(&Crypt, Encoded);
        AddEntryByColumbName(&NDBS, "Key2", Encoded, 8);

        KeyGen(8, GKNUMBERS|GKLOWER_AZ, Crypt.Data);
        fprintf(RawKeys, "%s\r\n", Crypt.Data);
        Encode(&Crypt, Encoded);
        AddEntryByColumbName(&NDBS, "Key3", Encoded, 8);

        LocalLoop++;
    }

    free(Crypt.Data);

    fclose(RawKeys);

    UninitializeCryptographySet(&Crypt);

    if(WriteNDBSFile(&NDBS, "C:\\CodedKeys.ndbs") == FALSE)
        return 0;

    FreeNDBS(&NDBS);

    return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

