//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <StdIO.H>

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "Headers/NSWFL.H"
#include "Headers/NASCCL.H"
#include "Headers/NDBSCore.H"
#include "Headers/NDBSFIO.H"

#define KeyToUse       "LhDTiyrCQ6fues5pXEuo2i4Mg3IgvXe4STWQEROgqHFX8eQwfySDUhg8QwqGmuIvt2F36jhT4FouWNEqtDoucTlgjuOnSVstBqs7QPCu4x84ndnNitydDgwUPmlgFtle"
#define KeyHashSize    1024

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool Compare(char *String1, char *String2, int Size)
{
	int LocalLoop = 0;

	while(LocalLoop < Size)
	{
		if(String1[LocalLoop] != String2[LocalLoop])
			return false;

        LocalLoop++;
	}

	return true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool VerifiyKey(char *RegisterFile, char *Key1, char *Key2, char *Key3)
{
    bool ReturnValue = false;

    _NASCCL Crypt;
    _NDataBaseSystem NDBS;

    int LocalLoop = 0;
    int Attribs   = (ROUNDMUTATION | SWAPMATRIX | ROUNDRESULT | NONREPETITION | ENSUREOFFSET | FMATRIXMUTATION | RMATRIXMUTATION | CMATRIXMUTATION | CRYPTFULLDATASET);

    char KeyHash[KeyHashSize];

    char HashValue[16 + 1][3 + 1];

    if(ReadNDBSFile(&NDBS, RegisterFile) == false)
        return false;

    HashKey(KeyToUse, KeyHash, strlen(KeyToUse), KeyHashSize);

    InitializeCryptographySet(&Crypt, KeyHash, KeyHashSize, Attribs);

    Crypt.Data = (char *) calloc(16 + 1, 1);

    Crypt.SizeOfData = 16;

    //------------------------------------------------------------------------------------

    HashKey(Key1, HashValue[0], 8, 16);
    HashKey(Key2, HashValue[1], 8, 16);
    HashKey(Key3, HashValue[2], 8, 16);

    while(LocalLoop < 10000)
    {
        char KeyValue[16 + 1][3 + 1];
        RetreiveDataByColumbPosition(&NDBS, 0, LocalLoop, Crypt.Data);
        Decode(&Crypt, KeyValue[0]);

        RetreiveDataByColumbPosition(&NDBS, 1, LocalLoop, Crypt.Data);
        Decode(&Crypt, KeyValue[1]);

        RetreiveDataByColumbPosition(&NDBS, 2, LocalLoop, Crypt.Data);
        Decode(&Crypt, KeyValue[2]);

        if( Compare(KeyValue[0], HashValue[0], 16) )
        {
            if( Compare(KeyValue[1], HashValue[1], 16) )
            {
                if( Compare(KeyValue[2], HashValue[2], 16) )
                {
                    FreeNDBS(&NDBS);
                    ReturnValue =  true;
                    break;
                }
            }
        }
        LocalLoop++;
    }

    UninitializeCryptographySet(&Crypt);

    FreeNDBS(&NDBS);

	return ReturnValue;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


int main(void)
{
//x9up23zb-xdsyzrcq-gcqk1mfh

    bool Return = VerifiyKey("C:\\BinaryKeys.ndbs", "x9up23zb", "xdsyzrcq", "gcqk1mfh");

    printf("Return: %d\n", Return);

    return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

